--Just want the output, not the messages
SET NOCOUNT ON; 

--populate table with all dates from 2009-12-28
IF OBJECT_ID('tempdb..#AllDates') IS NOT NULL DROP TABLE #AllDates;
CREATE TABLE #AllDates ([date] date);
declare @dt datetime = '2009-12-28'
declare @dtEnd datetime = '2020-07-14';
WHILE (@dt <= @dtEnd) BEGIN
    insert into #AllDates([date])
        values(@dt)
    SET @dt = DATEADD(day, 1, @dt)
END;

-- Populate incidence table - only count those occurrences
-- of the code where it is the first time the patient has had it
select FirstDiagnosis, count(*) as num into #Incidence from (
	select NHSNo, min(entrydate) as FirstDiagnosis from journal
	where ReadCode in ('ACTA17','ACTA18','ACTA19','ACTA22351EMIS','ACTA24202EMIS','ACTA8597BRID','ACTA8873EGTON','ACTA8874EGTON','ACTA8875EGTON','AMTA19407NEMIS','AMTA23852NEMIS','AMTA23853NEMIS','AMTA31816EMIS','AMTA31817EMIS','AMTA31818EMIS','AMTA31819EMIS','APTA31570EMIS','APTA31571EMIS','APTA31572EMIS','bA...','bA1..','bA11.','bA12.','bA1y.','bA1z.','bi...','bi1..','bi11.','bi12.','bi13.','bi14.','bi15.','bi16.','bi17.','bi18.','bi19.','bi1a.','bi1A.','bi1b.','bi1B.','bi1c.','bi1C.','bi1d.','bi1D.','bi1e.','bi1E.','bi1f.','bi1F.','bi1g.','bi1G.','bi1h.','bi1i.','bi1j.','bi1H.','bi1J.','bi1k.','bi1l.','bi1m.','bi1n.','bi1o.','bi1p.','bi1q.','bi1r.','bi1s.','bi1v.','bi1w.','bi1x.','bi1y.','bi1z.','bi2..','bi21.','bi22.','bi23.','bi24.','bi25.','bi26.','bi27.','bi28.','bi29.','bi2a.','bi2A.','bi2b.','bi2B.','bi2C.','bi2D.','bi2E.','bi2F.','bi2G.','bi2H.','bi2J.','bi2K.','bi2L.','bi2M.','bi2t.','bi2u.','bi2v.','bi2w.','bi2x.','bi2y.','bi2z.','bi3..','bi31.','bi32.','bi33.','bi34.','bi35.','bi36.','bi37.','bi38.','bi39.','bi3a.','bi3b.','bi3c.','bi3d.','bi3e.','bi3f.','bi3g.','bi3h.','bi3i.','bi3j.','bi3k.','bi3l.','bi3m.','bi3n.','bi3p.','bi3q.','bi3r.','bi3s.','bi3t.','bi3u.','bi3v.','bi3w.','bi3x.','bi3y.','bi4..','bi41.','bi42.','bi43.','bi44.','bi45.','bi46.','bi47.','bi48.','bi49.','bi4A.','bi4B.','bi4C.','bi4D.','bi4E.','bi4F.','bi5..','bi51.','bi52.','bi53.','bi54.','bi55.','bi56.','bi57.','bi58.','bi6..','bi61.','bi62.','bi63.','bi64.','bi65.','bi66.','bi67.','bi68.','bi69.','bi6A.','bi6B.','bi6C.','bi6D.','bi6E.','bi6F.','bi6G.','bi6o.','bi6p.','bi6q.','bi6r.','bi6s.','bi6t.','bi6u.','bi6v.','bi6w.','bi6x.','bi6y.','bi6z.','bi7..','bi71.','bi72.','bi73.','bi74.','bi8..','bi81.','bi82.','bi83.','bi84.','bi85.','bi86.','bi87.','bi88.','bi89.','bi8a.','bi9..','bi91.','bi92.','bi93.','bi94.','bi95.','bi96.','bi97.','bi98.','bi99.','bi9A.','bi9z.','biA..','biA1.','biA2.','biA3.','biA4.','biB..','biB1.','biB2.','biB3.','biBx.','biBy.','biBz.','biC..','biC1.','biC2.','biC3.','biC4.','biC5.','biC6.','biC7.','biC8.','bk...','bk3..','bk31.','bk32.','bk33.','bk34.','bk35.','bk36.','bk37.','bk38.','bk39.','bk3A.','bk3B.','bk3C.','bk3D.','bk3E.','bk3F.','bk3G.','bk3H.','bk3y.','bk3z.','bk4..','bk41.','bk42.','bk43.','bk44.','bk45.','bk46.','bk47.','bk48.','bk49.','bk4A.','bk4B.','bk4C.','bk4u.','bk4v.','bk4w.','bk4x.','bk4y.','bk4z.','bk5..','bk51.','bk52.','bk53.','bk54.','bk55.','bk56.','bk57.','bk58.','bk59.','bk5x.','bk5y.','bk5z.','bk6..','bk61.','bk62.','bk7..','bk71.','bk72.','bk73.','bk74.','bk75.','bk76.','bk77.','bk78.','bk79.','bk7z.','bk8..','bk81.','bk82.','bk83.','bk84.','bk85.','bk86.','bk87.','bk88.','bk8w.','bk8x.','bk8y.','bk8z.','bk9..','bk91.','bk92.','bk93.','bk9x.','bk9y.','bk9z.','bkB..','bkB1.','bkB2.','bkB3.','bkB4.','bkB5.','bkB6.','bkC..','bkC1.','bkC2.','bkC3.','bkCx.','bkCy.','bkCz.','bkD..','bkD1.','bkD2.','bkD3.','bkDx.','bkDy.','bkDz.','bkH..','bkH1.','bkH2.','bkH3.','bkHx.','bkHy.','bkHz.','CATA1598NEMIS','CATA1599NEMIS','CATA18202NEMIS','CATA18203NEMIS','CATA19406NEMIS','CATA19668EMIS','CATA24703EMIS','CATA31824EMIS','CATA31825EMIS','CATA31826EMIS','CATA31827EMIS','CATA4675','CATA480','CATA481','CATA482','CATA483','CATA484','CATA8616EGTON','CATA8617EGTON','CATA8618EGTON','CATA8619EGTON','CATA8735BRIDL','CATA9093EMIS','CITA18897EMIS','CITA18898EMIS','CITA18899EMIS','CITA18900EMIS','CITA21966EMIS','COOR37465NEMIS','COTA12634NEMIS','COTA12941NEMIS','COTA14418NEMIS','COTA1596NEMIS','COTA1597NEMIS','COTA18415NEMIS','COTA18416NEMIS','COTA18922NEMIS','COTA21151NEMIS','COTA23522NEMIS','COTA26210EMIS','COTA26211EMIS','COTA28963NEMIS','COTA29341NEMIS','COTA29342NEMIS','COTA29343NEMIS','COTA29347NEMIS','COTA30977EMIS','COTA35194NEMIS','COTA37620MGEMIS','COTA37621MGEMIS','COTA37622MGEMIS','COTA37623MGEMIS','COTA37624MGEMIS','COTA37625MGEMIS','COTA37626MGEMIS','COTA37627MGEMIS','COTA5665NEMIS','COTA5666NEMIS','COTA9937BRIDL','COTA9939BRIDL','DICA29699EMIS','DICA29700EMIS','DICA29701EMIS','DIOR52801NEMIS','DITA19083NEMIS','DITA28965NEMIS','ECTA15781NEMIS','ECTA15782NEMIS','ECTA15783NEMIS','ENTA1060','ENTA1062','ENTA1063','ENTA18559NEMIS','ENTA6935','ENTI23994EMIS','ENWA31548LEEDS','ENWA31549LEEDS','ENWA31550LEEDS','ENWA31551LEEDS','ENWA31764EMIS','ENWA31765EMIS','ENWA31766EMIS','ENWA31767EMIS','EPTA3293NEMIS','EPTA3295NEMIS','EPTA3296NEMIS','EXTA23855NEMIS','EXTA23856NEMIS','EXTA23857NEMIS','FOTA9320EMIS','FOTA9321EMIS','GOCA16732NEMIS','GOCA23759EMIS','GOCA23760EMIS','GOCA23761EMIS','HYTA33752EMIS','HYTA33753EMIS','HYTA33754EMIS','IMTA35377EMIS','IMTA35378EMIS','IMTA4732NEMIS','INTA1470','INTA1471','INTA1472','INTA1473','INTA9233EMIS','INTI23991EMIS','INWA31540LEEDS','INWA31541LEEDS','INWA31542LEEDS','INWA31543LEEDS','INWA31756EMIS','INWA31757EMIS','INWA31758EMIS','INWA31759EMIS','IRTA18540NEMIS','IRTA18541NEMIS','IRTA23521NEMIS','IRTA31576EMIS','IRTA31577EMIS','IRTA31578EMIS','KATA32855EMIS','KATA32856EMIS','KATA32857EMIS','LITA18535NEMIS','LITA18536NEMIS','LITA20104NEMIS','LITA20105NEMIS','LITA8608EGTON','LITA8609EGTON','LITA8610EGTON','LITA8611EGTON','LOCA18516NEMIS','LOCA18517NEMIS','LOCA18518NEMIS','LOOR37464NEMIS','LOTA12633NEMIS','LOTA18550NEMIS','LOTA21150NEMIS','LOTA26214EMIS','LOTA26215EMIS','LOTA28962NEMIS','LOTA35193NEMIS','MITA1045NEMIS','MITA1046NEMIS','MITA14652NEMIS','MITA14653NEMIS','MITA30444NEMIS','MITA6417NEMIS','MOTA28131EMIS','MOTA28132EMIS','ODCA23765EMIS','ODCA23766EMIS','ODCA23767EMIS','OLTA15758NEMIS','OLTA15760NEMIS','OLTA15761NEMIS','OLTA15763NEMIS','OLTA15764NEMIS','OLTA15765NEMIS','OLTA22330NEMIS','OLTA22331NEMIS','OLTA22333NEMIS','OLTA22334NEMIS','OLTA35715NEMIS','OLTA35716NEMIS','OLTA35717NEMIS','OLTA42106NEMIS','OLTA42107NEMIS','PETA14419NEMIS','PETA18548NEMIS','PETA28127EMIS','PETA28128EMIS','PETA29336NEMIS','PETA29338NEMIS','PETA29339NEMIS','PETA29345NEMIS','PETA9809HILLI','PETA9810HILLI','PRTA1932NEMIS','PRTA1933NEMIS','PRTA1934NEMIS','PRTA1935NEMIS','QUTA10125BRIDL','QUTA10127BRIDL','QUTA10129BRIDL','QUTA10131BRIDL','QUTA18531NEMIS','QUTA20155NEMIS','QUTA20156NEMIS','QUTA20157NEMIS','QUTA20158NEMIS','RACA19070NEMIS','RACA19071NEMIS','RACA19072NEMIS','RACA19073NEMIS','RACA36826MGEMIS','RACA36827MGEMIS','RACA36828MGEMIS','RACA36829MGEMIS','RACA36830MGEMIS','RACA36831MGEMIS','RACA36832MGEMIS','RACA36833MGEMIS','RACA36834MGEMIS','RACA36835MGEMIS','RACA36836MGEMIS','RACA36837MGEMIS','RACA36838MGEMIS','RACA36839MGEMIS','RACA36840MGEMIS','RACA36841MGEMIS','RACA36842MGEMIS','RACA36843MGEMIS','RACA36844MGEMIS','RACA36845MGEMIS','RACA37593MGEMIS','RACA37594MGEMIS','RACA37595MGEMIS','RACA37596MGEMIS','RACA37597MGEMIS','RACA37598MGEMIS','RACA37599MGEMIS','RACA37600MGEMIS','RACA37601MGEMIS','RACA37602MGEMIS','RACA57NEMIS','RACA8950EMIS','RACA8951EMIS','RACA8952EMIS','RAOR33337NEMIS','RAOR45589NEMIS','RAOR45617NEMIS','RAOR45619NEMIS','RAOR46795NEMIS','RAOR52661NEMIS','RAPO22025NEMIS','RASU14943NEMIS','RASU25475NEMIS','RASU45590NEMIS','RATA16399NEMIS','RATA16400NEMIS','RATA16401NEMIS','RATA16402NEMIS','RATA18576NEMIS','RATA18577NEMIS','RATI12695NEMIS','SETA35719NEMIS','SETA35720NEMIS','SETA35721NEMIS','SETA48962NEMIS','SETA48963NEMIS','SETA48964NEMIS','SETA48965NEMIS','SETA48966NEMIS','STTA9316EMIS','STTA9317EMIS','TAM/31589EMIS','TATA35373EMIS','TATA35374EMIS','TATA4731NEMIS','TETA1042NEMIS','TETA1044NEMIS','TETA15547NEMIS','TETA15548NEMIS','TETA15549NEMIS','TETA18566NEMIS','TETA18567NEMIS','TETA3339NEMIS','TETA3340NEMIS','TETA3341NEMIS','TETA6416NEMIS','TRCA16731NEMIS','TRCA23771EMIS','TRCA23772EMIS','TRCA23773EMIS','TRCA58NEMIS','TRCA8944EMIS','TRCA8945EMIS','TRCA8946EMIS','TRM/18572NEMIS','TRTA16403NEMIS','TRTA16404NEMIS','TRTA16405NEMIS','TRTA16406NEMIS','TRTA30134NEMIS','TRTA828NEMIS','TRTA829NEMIS','TRTI12696NEMIS','VACA29705EMIS','VACA29706EMIS','VACA29707EMIS','VAOR52800NEMIS','VATA18545NEMIS','VATA18546NEMIS','VATA18921NEMIS','VATA19082NEMIS','VATA21964EMIS','VATA28964NEMIS','VATA9150EMIS','VATA9151EMIS','VATA9152EMIS','VATA9153EMIS','ZETA24152EMIS','ZETA8600EGTON','ZETA8601EGTON','ZETA8602EGTON','ZETA8603EGTON','ZETA9096EMIS','AMTA23851NEMIS','bi1I.','bi1K.','bk4s.','bk4t.','bkI1.','bkI..','bkI2.','bkI3.','bkI4.','bkI5.','bkJ..','bkJ1.','bkJ2.','bkJ3.','bkJ4.','bkJ5.','bkJ6.','bkL..','bkL1.','bkL2.','bkL3.','bkL4.','bkL5.','bkL6.','CAOR16699NEMIS','CAOR37227NEMIS','CATA27881EMIS','ENOR20099NEMIS','LIOR46489NEMIS','LISU18409NEMIS','OLOR27110NEMIS','PEOR25486NEMIS','PEOR45595NEMIS','TETA30443NEMIS','VATA52642NEMIS')
	and entrydate <= '2020-07-14'
	group by NHSNo
) sub 
where FirstDiagnosis >= '2009-12-28'
group by FirstDiagnosis

-- Populate prevalence table - count all occurrences of the 
-- code irrespective of whether it is the first time the patient has had it
select entrydate, count(*) as num into #Prevalence from (
	select NHSNo, entrydate from journal
	where ReadCode in ('ACTA17','ACTA18','ACTA19','ACTA22351EMIS','ACTA24202EMIS','ACTA8597BRID','ACTA8873EGTON','ACTA8874EGTON','ACTA8875EGTON','AMTA19407NEMIS','AMTA23852NEMIS','AMTA23853NEMIS','AMTA31816EMIS','AMTA31817EMIS','AMTA31818EMIS','AMTA31819EMIS','APTA31570EMIS','APTA31571EMIS','APTA31572EMIS','bA...','bA1..','bA11.','bA12.','bA1y.','bA1z.','bi...','bi1..','bi11.','bi12.','bi13.','bi14.','bi15.','bi16.','bi17.','bi18.','bi19.','bi1a.','bi1A.','bi1b.','bi1B.','bi1c.','bi1C.','bi1d.','bi1D.','bi1e.','bi1E.','bi1f.','bi1F.','bi1g.','bi1G.','bi1h.','bi1i.','bi1j.','bi1H.','bi1J.','bi1k.','bi1l.','bi1m.','bi1n.','bi1o.','bi1p.','bi1q.','bi1r.','bi1s.','bi1v.','bi1w.','bi1x.','bi1y.','bi1z.','bi2..','bi21.','bi22.','bi23.','bi24.','bi25.','bi26.','bi27.','bi28.','bi29.','bi2a.','bi2A.','bi2b.','bi2B.','bi2C.','bi2D.','bi2E.','bi2F.','bi2G.','bi2H.','bi2J.','bi2K.','bi2L.','bi2M.','bi2t.','bi2u.','bi2v.','bi2w.','bi2x.','bi2y.','bi2z.','bi3..','bi31.','bi32.','bi33.','bi34.','bi35.','bi36.','bi37.','bi38.','bi39.','bi3a.','bi3b.','bi3c.','bi3d.','bi3e.','bi3f.','bi3g.','bi3h.','bi3i.','bi3j.','bi3k.','bi3l.','bi3m.','bi3n.','bi3p.','bi3q.','bi3r.','bi3s.','bi3t.','bi3u.','bi3v.','bi3w.','bi3x.','bi3y.','bi4..','bi41.','bi42.','bi43.','bi44.','bi45.','bi46.','bi47.','bi48.','bi49.','bi4A.','bi4B.','bi4C.','bi4D.','bi4E.','bi4F.','bi5..','bi51.','bi52.','bi53.','bi54.','bi55.','bi56.','bi57.','bi58.','bi6..','bi61.','bi62.','bi63.','bi64.','bi65.','bi66.','bi67.','bi68.','bi69.','bi6A.','bi6B.','bi6C.','bi6D.','bi6E.','bi6F.','bi6G.','bi6o.','bi6p.','bi6q.','bi6r.','bi6s.','bi6t.','bi6u.','bi6v.','bi6w.','bi6x.','bi6y.','bi6z.','bi7..','bi71.','bi72.','bi73.','bi74.','bi8..','bi81.','bi82.','bi83.','bi84.','bi85.','bi86.','bi87.','bi88.','bi89.','bi8a.','bi9..','bi91.','bi92.','bi93.','bi94.','bi95.','bi96.','bi97.','bi98.','bi99.','bi9A.','bi9z.','biA..','biA1.','biA2.','biA3.','biA4.','biB..','biB1.','biB2.','biB3.','biBx.','biBy.','biBz.','biC..','biC1.','biC2.','biC3.','biC4.','biC5.','biC6.','biC7.','biC8.','bk...','bk3..','bk31.','bk32.','bk33.','bk34.','bk35.','bk36.','bk37.','bk38.','bk39.','bk3A.','bk3B.','bk3C.','bk3D.','bk3E.','bk3F.','bk3G.','bk3H.','bk3y.','bk3z.','bk4..','bk41.','bk42.','bk43.','bk44.','bk45.','bk46.','bk47.','bk48.','bk49.','bk4A.','bk4B.','bk4C.','bk4u.','bk4v.','bk4w.','bk4x.','bk4y.','bk4z.','bk5..','bk51.','bk52.','bk53.','bk54.','bk55.','bk56.','bk57.','bk58.','bk59.','bk5x.','bk5y.','bk5z.','bk6..','bk61.','bk62.','bk7..','bk71.','bk72.','bk73.','bk74.','bk75.','bk76.','bk77.','bk78.','bk79.','bk7z.','bk8..','bk81.','bk82.','bk83.','bk84.','bk85.','bk86.','bk87.','bk88.','bk8w.','bk8x.','bk8y.','bk8z.','bk9..','bk91.','bk92.','bk93.','bk9x.','bk9y.','bk9z.','bkB..','bkB1.','bkB2.','bkB3.','bkB4.','bkB5.','bkB6.','bkC..','bkC1.','bkC2.','bkC3.','bkCx.','bkCy.','bkCz.','bkD..','bkD1.','bkD2.','bkD3.','bkDx.','bkDy.','bkDz.','bkH..','bkH1.','bkH2.','bkH3.','bkHx.','bkHy.','bkHz.','CATA1598NEMIS','CATA1599NEMIS','CATA18202NEMIS','CATA18203NEMIS','CATA19406NEMIS','CATA19668EMIS','CATA24703EMIS','CATA31824EMIS','CATA31825EMIS','CATA31826EMIS','CATA31827EMIS','CATA4675','CATA480','CATA481','CATA482','CATA483','CATA484','CATA8616EGTON','CATA8617EGTON','CATA8618EGTON','CATA8619EGTON','CATA8735BRIDL','CATA9093EMIS','CITA18897EMIS','CITA18898EMIS','CITA18899EMIS','CITA18900EMIS','CITA21966EMIS','COOR37465NEMIS','COTA12634NEMIS','COTA12941NEMIS','COTA14418NEMIS','COTA1596NEMIS','COTA1597NEMIS','COTA18415NEMIS','COTA18416NEMIS','COTA18922NEMIS','COTA21151NEMIS','COTA23522NEMIS','COTA26210EMIS','COTA26211EMIS','COTA28963NEMIS','COTA29341NEMIS','COTA29342NEMIS','COTA29343NEMIS','COTA29347NEMIS','COTA30977EMIS','COTA35194NEMIS','COTA37620MGEMIS','COTA37621MGEMIS','COTA37622MGEMIS','COTA37623MGEMIS','COTA37624MGEMIS','COTA37625MGEMIS','COTA37626MGEMIS','COTA37627MGEMIS','COTA5665NEMIS','COTA5666NEMIS','COTA9937BRIDL','COTA9939BRIDL','DICA29699EMIS','DICA29700EMIS','DICA29701EMIS','DIOR52801NEMIS','DITA19083NEMIS','DITA28965NEMIS','ECTA15781NEMIS','ECTA15782NEMIS','ECTA15783NEMIS','ENTA1060','ENTA1062','ENTA1063','ENTA18559NEMIS','ENTA6935','ENTI23994EMIS','ENWA31548LEEDS','ENWA31549LEEDS','ENWA31550LEEDS','ENWA31551LEEDS','ENWA31764EMIS','ENWA31765EMIS','ENWA31766EMIS','ENWA31767EMIS','EPTA3293NEMIS','EPTA3295NEMIS','EPTA3296NEMIS','EXTA23855NEMIS','EXTA23856NEMIS','EXTA23857NEMIS','FOTA9320EMIS','FOTA9321EMIS','GOCA16732NEMIS','GOCA23759EMIS','GOCA23760EMIS','GOCA23761EMIS','HYTA33752EMIS','HYTA33753EMIS','HYTA33754EMIS','IMTA35377EMIS','IMTA35378EMIS','IMTA4732NEMIS','INTA1470','INTA1471','INTA1472','INTA1473','INTA9233EMIS','INTI23991EMIS','INWA31540LEEDS','INWA31541LEEDS','INWA31542LEEDS','INWA31543LEEDS','INWA31756EMIS','INWA31757EMIS','INWA31758EMIS','INWA31759EMIS','IRTA18540NEMIS','IRTA18541NEMIS','IRTA23521NEMIS','IRTA31576EMIS','IRTA31577EMIS','IRTA31578EMIS','KATA32855EMIS','KATA32856EMIS','KATA32857EMIS','LITA18535NEMIS','LITA18536NEMIS','LITA20104NEMIS','LITA20105NEMIS','LITA8608EGTON','LITA8609EGTON','LITA8610EGTON','LITA8611EGTON','LOCA18516NEMIS','LOCA18517NEMIS','LOCA18518NEMIS','LOOR37464NEMIS','LOTA12633NEMIS','LOTA18550NEMIS','LOTA21150NEMIS','LOTA26214EMIS','LOTA26215EMIS','LOTA28962NEMIS','LOTA35193NEMIS','MITA1045NEMIS','MITA1046NEMIS','MITA14652NEMIS','MITA14653NEMIS','MITA30444NEMIS','MITA6417NEMIS','MOTA28131EMIS','MOTA28132EMIS','ODCA23765EMIS','ODCA23766EMIS','ODCA23767EMIS','OLTA15758NEMIS','OLTA15760NEMIS','OLTA15761NEMIS','OLTA15763NEMIS','OLTA15764NEMIS','OLTA15765NEMIS','OLTA22330NEMIS','OLTA22331NEMIS','OLTA22333NEMIS','OLTA22334NEMIS','OLTA35715NEMIS','OLTA35716NEMIS','OLTA35717NEMIS','OLTA42106NEMIS','OLTA42107NEMIS','PETA14419NEMIS','PETA18548NEMIS','PETA28127EMIS','PETA28128EMIS','PETA29336NEMIS','PETA29338NEMIS','PETA29339NEMIS','PETA29345NEMIS','PETA9809HILLI','PETA9810HILLI','PRTA1932NEMIS','PRTA1933NEMIS','PRTA1934NEMIS','PRTA1935NEMIS','QUTA10125BRIDL','QUTA10127BRIDL','QUTA10129BRIDL','QUTA10131BRIDL','QUTA18531NEMIS','QUTA20155NEMIS','QUTA20156NEMIS','QUTA20157NEMIS','QUTA20158NEMIS','RACA19070NEMIS','RACA19071NEMIS','RACA19072NEMIS','RACA19073NEMIS','RACA36826MGEMIS','RACA36827MGEMIS','RACA36828MGEMIS','RACA36829MGEMIS','RACA36830MGEMIS','RACA36831MGEMIS','RACA36832MGEMIS','RACA36833MGEMIS','RACA36834MGEMIS','RACA36835MGEMIS','RACA36836MGEMIS','RACA36837MGEMIS','RACA36838MGEMIS','RACA36839MGEMIS','RACA36840MGEMIS','RACA36841MGEMIS','RACA36842MGEMIS','RACA36843MGEMIS','RACA36844MGEMIS','RACA36845MGEMIS','RACA37593MGEMIS','RACA37594MGEMIS','RACA37595MGEMIS','RACA37596MGEMIS','RACA37597MGEMIS','RACA37598MGEMIS','RACA37599MGEMIS','RACA37600MGEMIS','RACA37601MGEMIS','RACA37602MGEMIS','RACA57NEMIS','RACA8950EMIS','RACA8951EMIS','RACA8952EMIS','RAOR33337NEMIS','RAOR45589NEMIS','RAOR45617NEMIS','RAOR45619NEMIS','RAOR46795NEMIS','RAOR52661NEMIS','RAPO22025NEMIS','RASU14943NEMIS','RASU25475NEMIS','RASU45590NEMIS','RATA16399NEMIS','RATA16400NEMIS','RATA16401NEMIS','RATA16402NEMIS','RATA18576NEMIS','RATA18577NEMIS','RATI12695NEMIS','SETA35719NEMIS','SETA35720NEMIS','SETA35721NEMIS','SETA48962NEMIS','SETA48963NEMIS','SETA48964NEMIS','SETA48965NEMIS','SETA48966NEMIS','STTA9316EMIS','STTA9317EMIS','TAM/31589EMIS','TATA35373EMIS','TATA35374EMIS','TATA4731NEMIS','TETA1042NEMIS','TETA1044NEMIS','TETA15547NEMIS','TETA15548NEMIS','TETA15549NEMIS','TETA18566NEMIS','TETA18567NEMIS','TETA3339NEMIS','TETA3340NEMIS','TETA3341NEMIS','TETA6416NEMIS','TRCA16731NEMIS','TRCA23771EMIS','TRCA23772EMIS','TRCA23773EMIS','TRCA58NEMIS','TRCA8944EMIS','TRCA8945EMIS','TRCA8946EMIS','TRM/18572NEMIS','TRTA16403NEMIS','TRTA16404NEMIS','TRTA16405NEMIS','TRTA16406NEMIS','TRTA30134NEMIS','TRTA828NEMIS','TRTA829NEMIS','TRTI12696NEMIS','VACA29705EMIS','VACA29706EMIS','VACA29707EMIS','VAOR52800NEMIS','VATA18545NEMIS','VATA18546NEMIS','VATA18921NEMIS','VATA19082NEMIS','VATA21964EMIS','VATA28964NEMIS','VATA9150EMIS','VATA9151EMIS','VATA9152EMIS','VATA9153EMIS','ZETA24152EMIS','ZETA8600EGTON','ZETA8601EGTON','ZETA8602EGTON','ZETA8603EGTON','ZETA9096EMIS','AMTA23851NEMIS','bi1I.','bi1K.','bk4s.','bk4t.','bkI1.','bkI..','bkI2.','bkI3.','bkI4.','bkI5.','bkJ..','bkJ1.','bkJ2.','bkJ3.','bkJ4.','bkJ5.','bkJ6.','bkL..','bkL1.','bkL2.','bkL3.','bkL4.','bkL5.','bkL6.','CAOR16699NEMIS','CAOR37227NEMIS','CATA27881EMIS','ENOR20099NEMIS','LIOR46489NEMIS','LISU18409NEMIS','OLOR27110NEMIS','PEOR25486NEMIS','PEOR45595NEMIS','TETA30443NEMIS','VATA52642NEMIS')
	and entrydate >= '2009-12-28'
	and entrydate <= '2020-07-14'
	group by NHSNo, entrydate
) sub 
group by entrydate

PRINT 'Date,IncidenceOfAcei,PrevalenceOfAcei'
select [date], ISNULL(i.num, 0), ISNULL(p.num, 0) from #AllDates d 
	left outer join #Incidence i on i.FirstDiagnosis = d.date
	left outer join #Prevalence p on p.entrydate = d.date
order by date;
